#!/usr1/local/bin/python
import sys, os, string, math

RANDOMY = 0.2

if len(sys.argv) == 4:
        LENWEIGHT = 1.0
        ANGWEIGHT = 1.0
        INTWEIGHT = 1.0
        CSWEIGHT = 1.0
        HWEIGHT = 1.0
        COMPWEIGHT = 1.0
	MISS_PENALTY = float(sys.argv[2])
	RANDOMX = float(sys.argv[3])/100	
elif len(sys.argv) == 10:
        LENWEIGHT = float(sys.argv[2])   
        ANGWEIGHT = float(sys.argv[4])   
        INTWEIGHT = float(sys.argv[5])   
        CSWEIGHT = float(sys.argv[7])   
        HWEIGHT = float(sys.argv[6])
        COMPWEIGHT = float(sys.argv[3])
	MISS_PENALTY = float(sys.argv[8])
	RANDOMX = float(sys.argv[9])/100
elif len(sys.argv) == 5:
	LENWEIGHT = 0.0
        ANGWEIGHT = 0.0
        INTWEIGHT = 0.0
        CSWEIGHT = 1.0
        HWEIGHT = 0.0
        COMPWEIGHT = 0.0
        MISS_PENALTY = float(sys.argv[2])
        RANDOMX = float(sys.argv[3])/100

FITA = ((RANDOMX*RANDOMY-RANDOMX)*(RANDOMX*RANDOMY-RANDOMY))/((RANDOMX-RANDOMY)*(RANDOMX-RANDOMY))
FITB = (RANDOMX-RANDOMX*RANDOMY)/(RANDOMX-RANDOMY)
FITC = (RANDOMX*RANDOMY-RANDOMY)/(RANDOMX-RANDOMY)
info1 = []
info2 = []
info3 = []
info4 = []
info5 = []
info6 = []
fp = open(sys.argv[1], "r")
info = fp.readlines()
for count, line in enumerate(info):
	word = line.split()
	if word:
		if word[0] == "length_weights:" or word[0] == "real_length:" or word[0] == "model_length:":
			info1.append(info[count+1])
                elif word[0] == "angle_weights:" or word[0] == "real_angle:" or word[0] == "model_angle:":
                        info2.append(info[count+1])
                elif word[0] == "interaction_weights:" or word[0] == "real_interaction:" or word[0] == "model_interaction:":
                        info3.append(info[count+1])
                elif word[0] == "packing_weights:" or word[0] == "real_packing:" or word[0] == "model_packing:":
                        info4.append(info[count+1])
		elif word[0] == "handedness_weights:" or word[0] == "real_handedness:" or word[0] == "model_handedness:":
			info5.append(info[count+1])
		elif word[0] == "contact_score:":
                        cs_score = float(info[count+1][:-1])
		elif word[0] == "distance_weights:" or word[0] == "real_distance:" or word[0] == "model_distance:":
                        info6.append(info[count+1])

#this part is for sse length score
weight = []
real = []
diffs = []
have_lens = 0
for count, line in enumerate(info1):
        word = line.split()
        if word and count == 0:
		for w in word:
			we = float(w)
			weight.append(we)
	elif word and count == 1:
		for r in word:
			re = float(r)
			real.append(re)
	elif word and count == 2:
		for n, v in enumerate(word):
			va = float(v)
			if va != -1:
				diffs.append(math.fabs(va-real[n]))
			else:
				diffs.append(-1)
if weight and real and diffs:
	tweight = sum(weight)
	scores = []
	for countd, dif in enumerate(diffs):
		if dif >= 0:
			s = math.pow(2,(-math.pow((dif/(0.25*real[countd])),2)))
		else:
			s = 0
		scores.append(s)
	lens = 0
	missse = 0
	for counts, sc in enumerate(scores):
		lens = lens + weight[counts]*sc/tweight
		if sc > 0:
			missse = missse + weight[counts]/tweight
        if missse != 0:
                lens = lens/missse*MISS_PENALTY
	have_lens = 1
else:
	lens = 0
#this part is for sse angle score
weight = []
real = []
diffs = []
have_angs = 0
for count, line in enumerate(info2):
        word = line[:-2].split("\t")
        if word and count == 0:
                for w in word:
			if w:
                        	we = float(w)
                        	weight.append(we)
        elif word and count == 1:
                for r in word:
			if r:
				rvec = []
				point_info = r[1:-1].split(",")
				for point in point_info:
					rvec.append(float(point))
                        	real.append(rvec)
        elif word and count == 2:
                for n, v in enumerate(word):
			if v == "N/A":
				diffs.append(-1)
			elif v:
				mvec = []
				point_info = v[1:-1].split(",")
				for point in point_info:
					mvec.append(float(point))
				cross = mvec[0]*real[n][0] + mvec[1]*real[n][1] + mvec[2]*real[n][2]
				if cross >= 1:
					diff = 0
				else:
					diff = math.acos(cross)
				diffs.append(diff)	
if weight and real and diffs:
	tweight = sum(weight)
	scores = []
	for countd, dif in enumerate(diffs):
		if dif >= 0:
       			s = math.pow(2,(-math.pow(dif/0.7,2)))
		else:
			s = 0
        	scores.append(s)
   
	angs = 0
	misang = 0
	for counts, sc in enumerate(scores):
        	angs = angs + weight[counts]*sc/tweight
		if sc > 0:
			misang = misang + weight[counts]/tweight

	if misang != 0:
        	angs = angs/misang*MISS_PENALTY
	have_angs = 1
else:
	angs = 0
#this part is for sse interaction score
weightraw = []
weight = []
real = []
model = []
diffs = []
posi = []
nega = []
have_ints = 0
for count, line in enumerate(info3):
        word = line.split()
        if word and count == 0:
                for countw, w in enumerate(word):
                        we = float(w)
			if we > 0:
				posi.append(we)
			else:
				nega.append(we)
                        weightraw.append(we)

        elif word and count == 1:
                for r in word:
                        re = float(r)
                        real.append(re)
        elif word and count == 2:
                for n, v in enumerate(word):
                        va = float(v)
			model.append(va)
			if va != -1:
				diffs.append(math.fabs(va-real[n]))
			else:
				diffs.append(-1)

if weightraw:
	for w in weightraw:
		if w > 0:
			weight.append(w)
		else:
			weight.append(-w) 

if weight and real and diffs:
	tweight = sum(weight) 
	scores = [] 
	for countd, dif in enumerate(diffs):
		if dif >= 0:
			if weightraw[countd] > 0:
        			s = math.pow(2,(-math.pow((dif/real[countd]),2)))
			else:
				if model[countd] != 0:
					s = math.pow(2,(-math.pow(dif/(model[countd]),2)))
				else:
					s = math.pow(2,(-math.pow(dif/1.0,2)))
		else:
			s = 0
        	scores.append(s)   

	ints = 0
	misint = 0
	for counts, sc in enumerate(scores):
        	ints = ints + weight[counts]*sc/tweight
		if sc > 0:
			misint = misint + weight[counts]/tweight

	if misint != 0:                                                
        	ints = ints/misint*MISS_PENALTY                                                
	have_ints = 1
else:
	ints = 0

#this part is for sse packing score
weight = []
real = []
diffs = []
have_coms = 0
for count, line in enumerate(info4):
        word = line.split()  
        if word and count == 0:
                for w in word:
                        we = float(w)
                        weight.append(we)
        elif word and count == 1:
                for r in word:
                        re = float(r)
                        real.append(re)
        elif word and count == 2:
                for n, v in enumerate(word):
                        va = float(v)
                        if va != -1:
                                diffs.append(math.fabs(va-real[n]))
                        else:
                                diffs.append(-1)

if weight and real and diffs:        
	tweight = sum(weight)
	scores = []
	for countd, dif in enumerate(diffs):
        	if dif >= 0:
                	s = math.pow(2,(-math.pow((dif/(0.5*real[countd])),2)))
        	else:   
                	s = 0
	        scores.append(s)

	coms = 0
	miscom = 0
	for counts, sc in enumerate(scores):
        	coms = coms + weight[counts]*sc/tweight
		if sc > 0:
			miscom = miscom + weight[counts]/tweight

	if miscom != 0:                                                
        	coms = coms/miscom*MISS_PENALTY                                                
	have_coms = 1
else:
	coms = 0


weight = []
real = []
diffs = []
have_diss = 0   
for count, line in enumerate(info6):
        word = line.split()
        if word and count == 0:
                for w in word:
                        we = float(w)
                        weight.append(we)
        elif word and count == 1:
                for r in word:
                        re = float(r)
                        real.append(re)
        elif word and count == 2:
                for n, v in enumerate(word):
                        va = float(v) 
                        if va > 0:
				if va >= real[n]:
                                	diffs.append(math.fabs(va-real[n]))
				else:
					diffs.append(math.fabs(real[n]*real[n]/va-real[n]))
                        else:
                                diffs.append(-1)

if weight and real and diffs:
        tweight = sum(weight)
        scores = []
        for countd, dif in enumerate(diffs):
                if dif >= 0:   
                        s = math.pow(2,(-math.pow((dif/(0.5*real[countd])),2)))
                else:
                        s = 0
                scores.append(s)
        
        diss = 0
        misdis = 0
        for counts, sc in enumerate(scores):
                diss = diss + weight[counts]*sc/tweight
                if sc > 0:
                        misdis = misdis + weight[counts]/tweight
                                        
        if misdis != 0:
                diss = diss/misdis*MISS_PENALTY
        have_diss = 1
else:
        diss = 0


#this part is for sse handedness score
weightraw = []
weight = []
real = []
include = []  
ref = []
diffs = []
have_hands = 0
for count, line in enumerate(info5):
        word = line[:-2].split("\t")
        if word and count == 0:
                for w in word:
			if w:
                        	we = float(w)
                        	weightraw.append(we)
        elif word and count == 1:
                for countr, r in enumerate(word):
			if r:
				if r[:3] == "N/A":
					real.append(0)
					ref.append(0)
				else:
					include.append(countr)				
	                        	real_info = r[1:-1].split(",")
        	                	real.append(float(real_info[0]))
                	        	ref.append(float(real_info[1]))
        elif word and count == 2:
                for n, v in enumerate(word):
			if n in include:
                        	if v == "N/A":
                                	diffs.append(-1)
                        	elif v:
                                	model_info = v[1:-1].split(",")
					model_dis = float(model_info[0])
					if model_dis*real[n] < 0:
						if math.fabs(model_dis) > math.fabs(real[n]):
							if math.fabs(2*real[n])/ref[n] > 1:
								diffs.append(1)
							else:
								diffs.append(math.fabs(2*real[n])/ref[n])
						else:
							if math.fabs(2*model_dis)/ref[n] > 1:
								diffs.append(1)
							else:
								diffs.append(math.fabs(2*model_dis)/ref[n])
					else:
                                		diffs.append(0)
for countw, w in enumerate(weightraw):
	if countw in include:
		weight.append(w)
if weight and real and diffs and ref:
        tweight = sum(weight)
        scores = []   
        for countd, dif in enumerate(diffs):
                if dif >= 0:
                        s = 1 - dif
                else:
                        s = -1
                scores.append(s)
        hands = 0
        mishand = 0
        for counts, sc in enumerate(scores):
		if sc >= 0:
	                hands = hands + weight[counts]*sc/tweight
                        mishand = mishand + weight[counts]/tweight
                
        if mishand != 0:
                hands = hands/mishand*MISS_PENALTY
        have_hands = 1
else:
	hands = 0

title = "scores\tlength_score\tposition_score\tangle_score\tinteraction_score\thandedness_score\tcontact_score\ttotal_score\tfinal_QCS\n"
headline = "weights\t"+str(LENWEIGHT)+"\t"+str(COMPWEIGHT)+"\t"+str(ANGWEIGHT)+"\t"+str(INTWEIGHT)+"\t"+str(HWEIGHT)+"\t"+str(CSWEIGHT)+"\t--\t--\n"
sl = lens*LENWEIGHT
sa = angs*ANGWEIGHT     
si = ints*INTWEIGHT
sp = (coms+diss)*COMPWEIGHT/2
sc = cs_score*CSWEIGHT
sh = hands*HWEIGHT
st = (sl + sa + si + sp + sc + sh)/(LENWEIGHT + ANGWEIGHT + INTWEIGHT + COMPWEIGHT + CSWEIGHT + HWEIGHT)
sq = FITA/(FITB - st) + FITC
newline = "scores_for_model\t"+str(lens*100)+"\t"+str(coms*50+diss*50)+"\t"+str(angs*100)+"\t"+str(ints*100)+"\t"+str(hands*100)+"\t"+str(cs_score*100)+"\t"+str(st*100)+"\t"+str(sq*100)+"\n"
rp = open(sys.argv[1]+".final", "w")
rp.write(title)
rp.write(headline)
rp.write(newline)
