# $Id: Parm.py 659 2007-11-05 21:05:51Z indraneel $

from Extparm import extparm

class PSSDParm(extparm):
    consecutive_ca_cutoff = 4.2;
    
    hdist_cutoff = 8.1;
    hdist_strict_limit = 6.4;
    
    hdih1_cutoff = -35.0;
    hdih2_cutoff = 115.0;
    hdih_optimal = 50.111;
    hdih_sigma = 8.603;
    hdih_sigma_range = 2.0;

    sdist_strict_limit = 8.1;
    sdih1_cutoff = -35.0;
    sdih2_cutoff = 115.0;
    
    max_sheet_pair_cutoff = 7.5;
    min_sheet_pair_cutoff = 3.5;
    
## syn_best_good_quad_score = 16.75;
## syn_worst_good_quad_score = 58.77;
## syn_best_bad_quad_score = 40.00;
## syn_worst_bad_quad_score = 104.37;
## anti_best_good_quad_score = 17.31;
## anti_worst_good_quad_score = 54.41;
## anti_best_bad_quad_score = 34.00;
## anti_worst_bad_quad_score = 95.68;

# syn_worst_good_quad_score = 45;
# syn_best_bad_quad_score = 46;
# anti_worst_good_quad_score = 44;
# anti_best_bad_quad_score = 39;

    syn_quad_cutoff = 45.0;
    anti_quad_cutoff = 39.0;

    syn_quad_cutoff_2 = 46.0;
    anti_quad_cutoff_2 = 44.0;
    
    syndistweight = 1.0;
    antidistweight = 1.0;
#    syn_dist_sigma = 0.227;
    syn_dist_sigma = 0.317;
    syn_dist_mean = 4.81;
#    anti_dist_sigma = 0.261;
    anti_dist_sigma = 0.365;
    anti_dist_mean_lo = 4.463;
    anti_dist_mean_hi = 5.245;
    dist_probfile = "dist_prob";
    
    
    synbondweight = 1.0;
    antibondweight = 1.0;
#    syn_bond_sigma = 2.5;
    syn_bond_sigma = 3.5;
    syn_bond_mean = 87.0;
#    anti_bond_sigma = 3.7;
    anti_bond_sigma = 5.1;
    anti_bond_mean = 82.2;
    bond_probfile = "bond_prob2";
    
    
    syntorsionarrowweight = 1.0;
    antitorsionarrowweight = 1.0;
#    syn_torsion_arrow_sigma = 15.6;
    syn_torsion_arrow_sigma = 21.8;
    syn_torsion_arrow_mean = -20.9;
#    anti_torsion_arrow_sigma = 25.6;
    anti_torsion_arrow_sigma = 35.8;
    anti_torsion_arrow_mean = -27.9;
    torsion_arrow_probfile = "torsion_arrow_prob2";
    
    sheet_bend_angle = 45.0;
    sheet_bulge_angle = 70.0;

    sheet_plane_angle = 110.0;

    strand_vector_bend_angle = 80;

    def __init__(self, conf):
        extparm.__init__(self, conf)
        c = self.max_sheet_pair_cutoff
        self.max_sheet_pair_cutoff_sqr = c * c
        c = self.min_sheet_pair_cutoff
        self.min_sheet_pair_cutoff_sqr = c * c
